﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Diagnostics;

namespace Crossword
{
    class Program
    {
        static int n, m,q;
        static string[] field = new string[501];
        static string fileread;
        static int L;
        static string word;
        static char[] myword = new char[51];
        static int[] F = new int[51];

        static int x, y, score;
        static bool foundplace;
        static bool vertic;

        static string[] future = new string[6];
        static int futureuk;
        static int futureL;

        static char[,] grid = new char[501, 501];
        static int[,] combs = new int[33, 5];

        static void Wait()
        {
            while (true)
            {

            }
            return;
        }

        static void WaitInput()
        {
            Console.ReadLine();
            return;
        }

        static void CheckWordPlace()
        {
            //Version 1.0 , random chance to intersect words

            int i, j;
            int lookfor = 0;
            int curscore = 0;
            int sx = 0, sy = 0;
            bool started = false;

            foundplace = false;
            score = 0;

            //Horizontal lines check
            for (i = 0; i < n; i++)
            {
                for (j = 0; j < m; j++)
                {
                    if (!started)
                    {
                        sx = i;
                        sy = j;
                        started = true;
                    }

                    if (grid[i,j] == '1')
                    {
                        lookfor = 0;
                        curscore = 0;
                        started = false;
                    }
                    else if (grid[i,j] == '0')
                    {
                        lookfor++;
                        curscore++;
                    }
                    else //letter
                    {
                        if (grid[i,j] == word[lookfor]) //lucky coincidence :)
                        {
                            lookfor++;
                            curscore = curscore + 2;
                        }
                        else
                        {
                            lookfor = 0;
                            curscore = 0;
                            started = false;
                        }
                    }

                    if (lookfor == L)//found a place
                    {
                        foundplace = true;

                        if (score < curscore)
                        {
                            score = curscore;
                            x = sx;
                            y = sy;
                            vertic = false;
                        }

                        lookfor = 0;
                        curscore = 0;
                        started = false;
                    }
                }

                lookfor = 0;
                curscore = 0;
                started = false;
            }

            //Vertical lines check
            for (i = 0; i < m; i++)
            {
                for (j = 0; j < n; j++)
                {
                    if (!started)
                    {
                        sx = j;
                        sy = i;
                        started = true;
                    }

                    if (grid[j,i] == '1')
                    {
                        curscore = 0;
                        lookfor = 0;
                        started = false;
                    }
                    else if (grid[j,i] == '0')
                    {
                        curscore++;
                        lookfor++;
                    }
                    else //letter
                    {
                        if (grid[j,i] == word[lookfor]) //lucky coincidence :)
                        {
                            curscore = curscore + 2;
                            lookfor++;
                        }
                        else
                        {
                            curscore = 0;
                            lookfor = 0;
                            started = false;
                        }
                    }

                    if (lookfor == L)
                    {
                        foundplace = true;

                        if (score < curscore)
                        {
                            score = curscore;
                            x = sx;
                            y = sy;
                            vertic = true;
                        }

                        started = false;
                        curscore = 0;
                        lookfor = 0;
                    }
                }
                started = false;
                lookfor = 0;
                curscore = 0;
            }

            return;
        }

        static void SlowCheckWordPlace()
        {
            //100% chance of intersection, too slow to be used every time

            int i,j,ind;
            int curscore;

            score=0;
            foundplace=false;

            for (i = 0; i < n; i++)
            {
                for (j = 0; j < m; j++)
                {
                    curscore = 0;

                    if (j+L-1 >= m)
                    {
                        continue;
                    }

                    for (ind = j; ind <= j + L - 1; ind++)
                    {
                        if (grid[i,ind] == word[ind - j])
                        {
                            curscore = curscore + 2;
                        }
                        else if (grid[i,ind] == '0')
                        {
                            curscore++;
                        }
                        else
                        {
                            curscore = 0;
                            break;
                        }
                    }

                    if (curscore > score)
                    {
                        score = curscore;
                        foundplace = true;
                        x = i;
                        y = j;
                        vertic = false;
                    }
                }
            }

            for (i = 0; i < m; i++)
            {
                for (j = 0; j < n; j++)
                {
                    curscore = 0;

                    if (j + L - 1 >= n)
                    {
                        continue;
                    }

                    for (ind = j; ind <= j + L - 1; ind++)
                    {
                        if (grid[ind,i] == word[ind - j])
                        {
                            curscore = curscore + 2;
                        }
                        else if (grid[ind,i] == '0')
                        {
                            curscore++;
                        }
                        else
                        {
                            curscore = 0;
                            break;
                        }
                    }

                    if (curscore > score)
                    {
                        score = curscore;
                        foundplace = true;
                        x = j;
                        y = i;
                        vertic = true;
                    }
                }
            }

            return;
        }


        static void ShowField()
        {
            int i, j;

            for (i = 0; i < n; i++)
            {
                for (j = 0; j < m; j++)
                {
                    Console.Write("{0} ", field[i][j]);
                }
                Console.WriteLine("");
            }

            return;
        }

        static void ShowGrid()
        {
            int i, j;

            for (i = 0; i < n; i++)
            {
                for (j = 0; j < m; j++)
                {
                    Console.Write("{0} ", grid[i,j]);
                }
                Console.WriteLine("");
            }

            return;
        }

        static void PlaceTheWord(int sx, int sy, bool ve)
        {
            int i;

            if (!ve)
            {
                for (i = sy; i <= sy + L - 1; i++)
                {
                    grid[sx, i] = word[i - sy];
                }
            }
            else
            {
                for (i = sx; i <= sx + L - 1; i++)
                {
                    grid[i, sy] = word[i - sx];
                }
            }
            return;
        }

        static char[,] backup = new char[501, 501];

        static void RememberGrid()
        {
            int i, j;

            for (i = 0; i < n; i++)
            {
                for (j = 0; j < m; j++)
                {
                    backup[i, j] = grid[i, j];
                }
            }
        }

        static void RestoreGrid()
        {
            int i, j;

            for (i = 0; i < n; i++)
            {
                for (j = 0; j < m; j++)
                {
                    grid[i, j] = backup[i, j];
                }
            }
        }

        static void Main(string[] args)
        {
            WebSystem.MyServiceClient client = new
            WebSystem.MyServiceClient();
            
            int i,j,ind;
            long thetime;
            int points;
            int testID;
            bool scared = false;
            long worstcasecomplexity;
            bool largetest = false, normaltest = false, smalltest = false;
            Stopwatch sw=Stopwatch.StartNew();
            int timeleft;
            int itleft;
            int totalscore;
            int maxscore,bestchoice;
            bool bad;
            int rem;
            int expectedscore = 0;

            StreamReader sr=new StreamReader ("crossword.in");
            fileread = sr.ReadLine();
            sr.Close();

            testID = int.Parse(fileread);

            client.Init(testID);

            n = client.getRowCount();
            m = client.getColumnCount();
            q = client.getQueryCount();

            worstcasecomplexity = n * m * q * 50;

            if (worstcasecomplexity > 300000000)
            {
                largetest = true;
            }
            else
            {
                normaltest = true;
            }
            
            field = client.getField();

            for (i=0;i<n;i++)
            {
                for (j=0;j<m;j++)
                {
                    grid[i,j]=field[i][j];
                }
            }

            for (i=1;i<=32;i++)
            {
                for (j=0;j<=4;j++)
                {
                    combs[i,j]=0;
                }
            }
            for (i = 2; i <= 32; i++)
            {
                for (j = 0; j <= 4; j++)
                {
                    combs[i,j] = combs[i - 1,j];
                }
                combs[i,4]++;
                for (j = 4; j >= 1; j--)
                {
                    if (combs[i,j] == 2)
                    {
                        combs[i,j] = 0;
                        combs[i,j - 1]++;
                    }
                }
            }

            //Console.WriteLine("{0}", q);
            for (i = 1; i <= q; i++)
            {
                //Console.WriteLine("i={0}",i);
                if (!scared)
                {
                    //Console.WriteLine("Not scared yo");
                    word = client.nextWord();

                    L = word.Length;

                    if (largetest)
                    CheckWordPlace();
                    else
                    SlowCheckWordPlace();

                    if (!foundplace)
                    {
                        client.placeWord(0, 0, false);
                        futureL = 0;
                        futureuk = 0;
                        scared = true;

                        worstcasecomplexity = (q - i) * n * m * 50 * 32;
                        timeleft=10000-(int)sw.ElapsedMilliseconds;
                        itleft=timeleft*30000;

                        if ( worstcasecomplexity < itleft )
                        {
                            smalltest = true;
                            normaltest = false;
                            largetest = false;
                        }

                    }
                    else
                    {
                        client.placeWord(x, y, vertic);
                        PlaceTheWord(x, y, vertic);

                        expectedscore = expectedscore + score;
                    }
                }
                else
                {
                    if (largetest || normaltest)
                    {
                        //Console.WriteLine("Never here");
                        if (futureuk >= futureL)
                        {
                            future = client.skip();
                            futureL = future.Length;
                            futureuk = 0;
                            continue;
                        }
                        else
                        {
                            word = future[futureuk];
                            futureuk++;

                            L = word.Length;

                            if (largetest)
                                CheckWordPlace();
                            else
                                SlowCheckWordPlace();

                            if (!foundplace)
                            {
                                future = client.skip();
                                futureL = future.Length;
                                futureuk = 0;
                            }
                            else
                            {
                                word = client.nextWord();

                                client.placeWord(x, y, vertic);

                                PlaceTheWord(x, y, vertic);

                                expectedscore = expectedscore + score;
                            }
                        }
                    }
                    else //smalltest
                    {
                        if (futureL == 0)
                        {
                            ///Console.WriteLine("Skipping ha?");
                            future = client.skip();
                            futureL = future.Length;
                            futureuk = 0;
                            i++;

                            if (i > q)
                            break;
                        }
                        if (futureL > q - i + 1)
                        {
                            futureL = q - i + 1;
                        }
                        ///Console.WriteLine("{0}", futureL);

                        /*for (j = 0; j < futureL; j++)
                        {
                            Console.WriteLine(future[j]);
                        }*/

                        bestchoice=1;
                        maxscore=0;

                        for (j = 2; j <= 32; j++)
                        {
                            totalscore = 0;
                            bad=false;

                            RememberGrid();
                            for (ind = 0; ind <= futureL - 1; ind++)
                            {
                                if (combs[j,ind]==0)
                                {
                                    continue;
                                }

                                word = future[ind];
                                L = word.Length;
                                SlowCheckWordPlace();

                                if (!foundplace)
                                {
                                    bad=true;
                                    break;
                                }
                                else
                                {
                                    word=future[ind];
                                    PlaceTheWord(x,y,vertic);
                                    totalscore=totalscore+score;
                                }
                            }
                            RestoreGrid();

                            if (!bad)
                            {
                                if (totalscore>maxscore)
                                {
                                    maxscore=totalscore;
                                    bestchoice=j;
                                }
                            }
                        }

                        rem = futureL - 1;
                        
                        for (j = 0; j <= rem; j++)
                        {
                            if (combs[bestchoice, j] == 0)
                            {
                                //Console.WriteLine("Skip");
                                future = client.skip();
                                futureL = future.Length;
                                futureuk = 0;
                            }
                            else
                            {
                                //Console.WriteLine("Put word");
                                word = client.nextWord();
                                L = word.Length;
                                SlowCheckWordPlace();
                                client.placeWord(x, y, vertic);
                                PlaceTheWord(x, y, vertic);
                                futureuk++;
                                expectedscore = expectedscore + score;
                            }
                            i++;
                            //Console.WriteLine("I={0}", i);
                        }
                        i--;

                        //Console.WriteLine("{0}", futureuk);

                        for (j = futureuk; j <= futureL - 1; j++)
                        {
                            future[j - futureuk] = future[j];
                        }
                        futureL = futureL - futureuk;
                        futureuk = 0;
                    }
                }
            }

            points = client.EndGame(out thetime);
        }
    }
}
